;-----------------------------------------------------------------------------
; DOS.INC - Some extract from dgVoodooConfig and DOS.H for the assembly
;
; Copyright (C) 2003 Dege
;
; This library is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License as published by the Free Software Foundation; either
; version 2.1 of the License, or (at your option) any later version.
;
; This library is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Lesser General Public License for more details.
;
; You should have received a copy of the GNU Lesser General Public
; License along with this library; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;-----------------------------------------------------------------------------

;------------------------------------------------------------------------------------------
; Defincik, amelyek a Dos-os s Windows-os DLL-ben is kellenek
;------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------------
;A wrapper konfigurcijt ler struktra
dgVoodooConfig  STRUC

ProductVersion  DW	?
GlideVersion    DW	?
TexMemSize      DD      ?
Flags           DD      ?
Gamma           DD      ?
Version         DD      ?
VideoMemSize_c  DD      ?
VideoRefreshFreq DD     ?
dxres           DW      ?
dyres           DW      ?
dispdev         DW      ?
dispdriver      DW      ?
reserved_c      DD      4 DUP(?)

dgVoodooConfig  ENDS

;------------------------------------------------------------------------------------------
; Alaprtelmezett rtkek a config struktra mezihez
MAXTEXNUM_D     EQU     2048            ;Textrk max. szma
TEXTUREMEMSIZE  EQU     4*1024*1024     ;Voodoo-textramem mrete

;------------------------------------------------------------------------------------------
; Konstansok a konfig struktra flagjeihez
CFG_WBUFFER				EQU		1h			;W-buffert mindig Z-bufferen keresztl emull
CFG_RELYONDRIVERFLAGS	EQU		CFG_WBUFFER
CFG_WINDOWED			EQU		2h			;Ablakos md
CFG_DISPMODE32BIT		EQU		4h			;32 bites videomd
CFG_SETREFRESHRATE		EQU		8h			;A frisstsi freq-t az alkalmazs
											;	lltja be (egybknt az akt. freq)
CFG_PERFECTTEXMEM		EQU		10h			;	Tkletes textramemria-emulci
CFG_WBUFFERMETHODISFORCED EQU	80h			;	A W-bufferels mdszere knyszertett:
											;		- CFG_WBUFFER flag set: mindig valdi w-bufferels
											;		- CFG_WBUFFER flag not set: mindig emullt w-bufferels
											;						vagy a W-bufferels mdszere detektlt, ekkor
											;		- CFG_RELYONDRIVERFLAGS set: a driver ltal a W-bufferels tmogatsra
											;								 visszaadott flag alapjn dnt
CFG_VESAENABLE          EQU     100h        ;Beptett VESA-tmogats engedlyezve
CFG_SETMOUSEFOCUS       EQU     200h        ;Egrfkusz az alkalmazsnl
CFG_SUPPORTMODE13H      EQU     400h        ;320x200x256 VGA-md tmogatsa
CFG_TEXTURES32BIT       EQU     800h        ;mindig 32 bites textrk
CFG_TEXTURES16BIT       EQU     1000h       ;mindig 16 bites textrk
CFG_TEXTURERELOAD       EQU     2000h       ;Textrk jratltse, ha kell
CFG_GRABENABLE          EQU     4000h       ;Kpernylops engedlyezve
CFG_GRABCLIPBOARD       EQU     8000h       ;Kplops a vglapra
CFG_CKMGEFORCE          EQU     10000h      ;Colorkeying GeForce-ra (2-es mdszer)
CFG_TOMBRAIDER          EQU     20000h      ;TR1 rnykhiba-javts
CFG_HUNGARIAN           EQU     40000h      ;A nyelv magyar
CFG_HWLFBCACHING        EQU     80000h      ;Hardveres gyorstpufferek az LFB-hez
CFG_LFBREALVOODOO       EQU     100000h     ;Kzelebb az igazi hardverhez
CFG_TRIPLEBUFFER        EQU     200000h     ;Mindig triplapufferels
CFG_ACTIVEBACKGROUND    EQU     400000h     ;A httren is aktv a DOS-os prg
CFG_LFBFASTUNMATCHWRITE EQU     800000h     ;Gyorsrs a nem egyez LFB formtumokhoz
CFG_CTRLALT             EQU     1000000h    ;Egrfkusz elengedse Ctrl-Alt-ra
CFG_VSYNC               EQU     2000000h    ;Fggleges visszafutst mindig megvrni
CFG_NTVDDMODE           EQU     4000000h    ;a wrapper VDD-mdban mkdik (XP-hez)
CFG_DISABLEMIPMAPPING   EQU     8000000h    ;Mipmapping tiltsa
CFG_ENABLEGAMMARAMP     EQU     10000000h   ;Glide-gammaramp engedlyezse
CFG_ENABLEHWVBUFFER     EQU     20000000h   ;Hardveres vertex pufferek hasznlata
CFG_BILINEARFILTER      EQU     40000000h   ;Mindig bilineris szrs a textrkhoz
CFG_CLIPPINGBYD3D       EQU     80000000h   ;Vgs a Direct3D-n keresztl

CFG2_CLOSESTREFRESHFREQ EQU     1h
CFG_FORCECLIPOPF        EQU     2h          ;CLI/POPF megfelel kezelse - rejtett opci
CFG_LFBRESCALECHANGESONLY EQU   4h          ;eltr felbontsok esetn csak a vltozsok tmretezse,
                                            ; s nem az egsz kp (gyorsrst ignyel) - rejtett opci
CFG_LFBFORCEFASTWRITE   EQU   8h            ;Gyorsrs hasznlata egyez formtumokhoz is - rejtett opci
CFG_YMIRROR             EQU   10h           ;Kperny fggleges tkrzse (orig-tesztekhez) - rejtett opci
CFG_FORCETRILINEARMIPMAPS EQU   20h         ;Trilineris mipmapping knyszertse - rejtett opci
CFG_PREFERTMUWIFPOSSIBLE  EQU   40h         ;tbls kd, z-buffer s TMUDIFFW hint esetn a tmu w-t
CFG_LFBALWAYSFLUSHWRITES  EQU	80h	    ;A rgi lfb-unlock dude-mdja: mindig kirja a vltozsokat
					    ;(nem cache-el) (kompatibilitsi s teszt-opci, rejtett)
CFG_DEPTHEQUALTOCOLOR	EQU	100h	    ;A kppuffer s a mlysgi puffer bitmlysge legyen mindig egyenl								    ;(kompatibilitsi s teszt-opci, rejtett)
CFG_DISABLELFBREAD	EQU	200h	    ;LFB elrsnek tiltsa olvassra
CFG_DISABLELFBWRITE	EQU	400h	    ;LFB elrsnek tiltsa rsra
CFG_AUTOGENERATEMIPMAPS	EQU	800h	    ;A hinyz mipmap-szintek automatikus generlsa
CFG_LFBNOMATCHINGFORMATS  EQU	1000h	    ;Az LFB-formtumok mindig klnbznek tekintendk - rejtett opci
CFG_ALWAYSINDEXEDPRIMS	EQU	2000h		
CFG_HIDECONSOLE		EQU	4000h	    ;Konzol elrejtse (DOS)
CFG_LFBENABLETEXTURING	EQU	8000h
CFG_CFORMATAFFECTLFB	EQU	10000h
CFG_DISABLEVESAFLATLFB	EQU	20000h


;A konfig flagekben lev bitmezk rtkei
CFG_CKMAUTOMATIC	EQU	00
CFG_CKMALPHABASED	EQU	01
CFG_CKMNATIVE		EQU	02
CFG_CKMNATIVETNT	EQU	03

;------------------------------------------------------------------------------------------
;Az egyes platformok kdjai
PLATFORM_WINDOWS          EQU   0
PLATFORM_DOSWIN9X         EQU   1
PLATFORM_DOSWINNT         EQU   2

;------------------------------------------------------------------------------------------
; Az aktulis videmd s annak pixelformtuma (VESA-hoz)

dgVoodooModeInfo        STRUC

ModeNumber              DW      ?
XRes                    DW      ?
YRes                    DW      ?
BitPP                   DB      ?
RedSize                 DB      ?
RedPos                  DB      ?
GreenSize               DB      ?
GreenPos                DB      ?
BlueSize                DB      ?
BluePos                 DB      ?
RsvSize                 DB      ?
RsvPos                  DB      ?
                        DB      ?

dgVoodooModeInfo        ENDS

;------------------------------------------------------------------------------------------
; Egrkurzor-inf: jelenleg hasznlaton kvli */
MouseInfo       STRUC

mi_x            DD      ?
mi_y            DD      ?
brecttop_x      DD      ?
brecttop_y      DD      ?
brectbottom_x   DD      ?
brectbottom_y   DD      ?

MouseInfo       ENDS

;------------------------------------------------------------------------------------------

EXEBUFFSIZE     EQU     ((32*1024)/4)
FUNCDATASIZE    EQU     1536*1024

KFLAG_INKERNEL  	EQU     1h
KFLAG_VMWINDOWED	EQU	2h
KFLAG_SCREENSHOT        EQU     4h
KFLAG_GLIDEACTIVE       EQU     8h
KFLAG_SERVERWORKING	EQU	20h
KFLAG_CTRLALT		EQU	80h
KFLAG_PALETTECHANGED	EQU	100h
KFLAG_VESAFRESHDISABLED EQU	200h

AREAID_COMMAREA                 EQU     1
AREAID_REGSTRUCTURE_GLIDE211    EQU     2
AREAID_REGSTRUCTURE_GLIDE243    EQU     3

; A kommunikcis terlet felptse (ez van az osztott memriaterleten)
CommArea        STRUC

areaId          DD      ?
kernelflag      DD      ?
ExeCodeIndex    DD      ?
FDPtr           DD      ?
progname        DB      128 DUP(?)
WinOldApHWND    DD      ?
VESAPalette     DD      256 DUP(?)
VESASession     DB      ?
VGAStateRegister3DA     DB      ?
VGARAMDACSize   DB      ?
                DB      ?
VideoMemory     DD      ?
videoMemoryClient DD	?
BytesPerScanLine DD     ?
DisplayOffset   DD      ?
actmodeinfo     dgVoodooModeInfo <>
;mouseinfo       MouseInfo <>

ExeCodes        DD      EXEBUFFSIZE DUP(?)
FuncData        DB      FUNCDATASIZE DUP(?)

;LFB		DB	0 DUP(?)

CommArea        ENDS

;------------------------------------------------------------------------------------------
ServerRegInfo   STRUC

areaId_regs     DD      ?
workerthread_   DD      ?
commaptr        DD      ?
VideoMemSize    DD      ?
ConfigPtr       DD      ?
ErrorCode       DD      ?

ServerRegInfo   ENDS


;------------------------------------------------------------------------------------------
; Az egyes Glide-fggvnyek kdjai

GRGLIDEINIT                     EQU             0
GRSSTWINOPEN                    EQU             1
GRSSTWINCLOSE                   EQU             2
GRGLIDESHUTDOWN                 EQU             3

GRBUFFERCLEAR                   EQU             4
GRBUFFERSWAP                    EQU             5

GUDRAWTRIANGLEWITHCLIP          EQU             6
GUAADRAWTRIANGLEWITHCLIP        EQU             7
GUDRAWPOLYGONVERTEXLISTWITHCLIP EQU             8
GRDRAWTRIANGLE                  EQU             9
GRDRAWPOLYGONVERTEXLIST         EQU             10
GRAADRAWPOLYGON                 EQU             11
GRAADRAWPOLYGONVERTEXLIST       EQU             12
GRAADRAWTRIANGLE                EQU             13
GRDRAWPLANARPOLYGON             EQU             14
GRDRAWPLANARPOLYGONVERTEXLIST   EQU             15
GRDRAWPOLYGON                   EQU             16
GRAADRAWLINE                    EQU             17
GRDRAWLINE                      EQU             18
GRAADRAWPOINT                   EQU             19
GRDRAWPOINT                     EQU             20


GRTEXDOWNLOADMIPMAP             EQU             21
GRTEXDOWNLOADMIPMAPLEVEL        EQU             22
GRTEXDOWNLOADMIPMAPLEVELPARTIAL EQU             23
GRTEXDOWNLOADTABLE              EQU             24
GRTEXDOWNLOADTABLEPARTIAL       EQU             25
GRTEXNCCTABLE                   EQU             26
GRTEXSOURCE                     EQU             27
GRTEXMIPMAPMODE                 EQU             28
GRTEXCOMBINE                    EQU             29
GRTEXFILTERMODE                 EQU             30
GRTEXCLAMPMODE                  EQU             31
GRTEXLODBIASVALUE               EQU             32
GRTEXMULTIBASE                  EQU             33
GRTEXMULTIBASEADDRESS           EQU             34

GUTEXALLOCATEMEMORY             EQU             35
GUTEXCHANGEATTRIBUTES           EQU             36
GUTEXCOMBINEFUNCTION            EQU             37
GUTEXDOWNLOADMIPMAP             EQU             38
GUTEXDOWNLOADMIPMAPLEVEL        EQU             39
GUTEXGETCURRENTMIPMAP           EQU             40
GUTEXGETMIPMAPINFO              EQU             41
GUTEXMEMQUERYAVAIL              EQU             42
GUTEXMEMRESET                   EQU             43
GUTEXSOURCE                     EQU             44
GU3DFGETINFO                    EQU             45
GU3DFLOAD                       EQU             46
GLIDEGETUTEXTURESIZE            EQU             47

GRCOLORCOMBINE                  EQU             48
GUCOLORCOMBINEFUNCTION          EQU             49
GRCONSTANTCOLORVALUE4           EQU             50
GRCOLORMASK                     EQU             51
GRCONSTANTCOLORVALUE            EQU             52
                                        
GRALPHABLENDFUNCTION            EQU             53
GRALPHACOMBINE                  EQU             54
GUALPHASOURCE                   EQU             55
GRALPHATESTFUNCTION             EQU             56
GRALPHATESTREFERENCEVALUE       EQU             57

GRFOGCOLORVALUE                 EQU             58
GRFOGMODE                       EQU             59
GRFOGTABLE                      EQU             60
GLIDEGETINDTOWTABLE             EQU             61
GUFOGTABLEINDEXTOW              EQU             62
GUFOGGENERATEEXP                EQU             63
GUFOGGENERATEEXP2               EQU             64
GUFOGGENERATELINEAR             EQU             65

GRRENDERBUFFER                  EQU             66
GRSSTORIGIN                     EQU             67
GRCLIPWINDOW                    EQU             68
GRCULLMODE                      EQU             69
GRDISABLEALLEFFECTS             EQU             70
GRDITHERMODE                    EQU             71
GRGAMMACORRECTIONVALUE          EQU             72
GRGLIDEGETSTATE                 EQU             73
GRGLIDESETSTATE                 EQU             74
GRHINTS                         EQU             75

GRSSTSCREENWIDTH                EQU             76
GRSSTSCREENHEIGHT               EQU             77
GRSSTSTATUS                     EQU             78
GRSSTVIDEOLINE                  EQU             79
GRSSTVRETRACEON                 EQU             80
GRSSTCONTROLMODE                EQU             81
GRBUFFERNUMPENDING              EQU             82
GRRESETTRISTATS                 EQU             83
GRTRISTATS                      EQU             84
                                        
GRDEPTHBUFFERMODE               EQU             85
GRDEPTHBUFFERFUNCTION           EQU             86
GRDEPTHMASK                     EQU             87
GRLFBCONSTANTALPHA              EQU             88
GRLFBREADREGION                 EQU             89
GRLFBWRITEREGION                EQU             90
GRDEPTHBIASLEVEL                EQU             91
GLIDEGETCONVBUFFXRES            EQU             92

GRCHROMAKEYMODE                 EQU             93
GRCHROMAKEYVALUE                EQU             94

GRLFBLOCK                       EQU             95
GRLFBUNLOCK                     EQU             96
GRLFBWRITECOLORFORMAT           EQU             97
GRLFBWRITECOLORSWIZZLE          EQU             98
GLIDESETUPLFBDOSBUFFERS         EQU             99

;Glide1-fggvnyek
GRSSTOPEN                       EQU             100
GRLFBBYPASSMODE                 EQU             101
GRLFBORIGIN                     EQU             102
GRLFBWRITEMODE                  EQU             103
GRLFBBEGIN                      EQU             104
GRLFBEND                        EQU             105
GRLFBGETREADPTR                 EQU             106
GRLFBGETWRITEPTR                EQU             107
GUFBREADREGION                  EQU             108
GUFBWRITEREGION                 EQU             109


;VESA-fggvnyek
VESASETVBEMODE                  EQU             110
VESAUNSETVBEMODE                EQU             111
VESAFRESH                       EQU             112

;Ezeket a fggvnyeket a kernelmodul hivja
DGVOODOOCLIENTCRASHED           EQU             113
DGVOODOONEWCLIENTREGISTERING    EQU             114

;Egyb fggvnyek
DGVOODOOGETCONFIG               EQU             115
DGVOODOORELEASEFOCUS            EQU             116

GLIDEINSTALLMOUSE		EQU		117
GLIDEUNINSTALLMOUSE		EQU		118
GLIDEISMOUSEINSTALLED		EQU		119

VESAGETXRES			EQU		120
VESAGETYRES			EQU		121

PORTLOG_IN			EQU		122
PORTLOG_OUT			EQU		123

GLIDEENDITEM                    EQU             0FFFFFFFFh
